unit ShakeBtn;

{              ShakeBtn V1.0

  Yet another fairly useless component by Harm.

  This component was developed for yet another
  beginner's Yahtzee clone.  It shakes when the
  mouse is over it and makes a 'dice shakin' sound.
  When clicked, it makes a 'dice rollin' sound.

  First (and probably last) release 9/98.

  If you like it, or want to know how I got sounds
  incorporated into a component, email me at
           harmans@uswest.net}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MMSystem;

type
  TShakeBtn = class(TButton)
  private
    { Private declarations }
    FTimer : TTimer;
    FL, FR : Boolean;
    procedure CMMouseEnter(var Msg:TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Msg:TMessage); message CM_MOUSELEAVE;
    procedure ShakeMe(Sender:TObject);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

{$R SHAKEBTN.RES}

constructor TShakeBtn.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FTimer := TTimer.Create(Self);
  with FTimer do begin
    Enabled := FALSE;
    Interval := 50;
    OnTimer := ShakeMe;
  end;
  FL :=  TRUE;
  FR := FALSE;
end;

procedure TShakeBtn.CMMouseEnter(var Msg:TMessage);
begin
  inherited;
  FTimer.Enabled := TRUE;
  PlaySound(PChar('SHAKE'), hInstance, snd_ASync or snd_Loop or snd_Resource);
end;

procedure TShakeBtn.CMMouseLeave(var Msg:TMessage);
begin
  inherited;
  FTimer.Enabled := FALSE;
  PlaySound(nil, hInstance, snd_ASync);
end;

procedure TShakeBtn.ShakeMe(Sender : TObject);
begin
  if FL = TRUE then begin
    Left := Left - 2;
    FL := not FL;
    if FR = TRUE then begin
      Top := Top + 1;
    end
    else begin
      Top := Top - 1;
    end;
    FR := not FR;
  end
  else begin
    Left := Left + 2;
    FL := not FL;
    if FR = TRUE then begin
      Top := Top + 1;
    end
    else begin
      Top := Top - 1;
    end;
    FR := not FR;
  end;
end;

procedure TShakeBtn.Click;
begin
  inherited Click;
  PlaySound(PChar('ROLL'), hInstance, snd_Sync or snd_Resource);
  FTimer.Enabled := FALSE;
end;

destructor TShakeBtn.Destroy;
begin
    FTimer.Free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TShakeBtn]);
end;

end.
